//---------------------------------------------------------------------------

#ifndef MachineModH
#define MachineModH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <DB.hpp>
#include <DBClient.hpp>
#include <msxmldom.hpp>
#include <XMLDoc.hpp>
#include <xmldom.hpp>
#include <XMLIntf.hpp>
//---------------------------------------------------------------------------
class TMachineDB : public TDataModule
{
__published:	// IDE-managed Components
	TClientDataSet *MachineRunLog;
	TClientDataSet *MachineErrorTable;
	TLargeintField *MachineErrorTableErrorCode;
	TStringField *MachineErrorTableErrorString;
	TStringField *MachineErrorTableErrorDateTime;
	TIntegerField *MachineErrorTableErrorSeverity;
	TStringField *MachineErrorTableAction;
	TAutoIncField *MachineErrorTableErrorID;
	TClientDataSet *MachineProperties;
	TIntegerField *MachinePropertiesID;
	TStringField *MachinePropertiesSerialNumber;
	TStringField *MachinePropertiesCOMPort;
	TStringField *MachinePropertiesName;
	TStringField *MachinePropertiesGUID;
	TXMLDocument *MachineDesired;
	TXMLDocument *MachineActual;
	TXMLDocument *MachineFlags;
	TXMLDocument *MachinePropXML;
	TXMLDocument *ErrorXML;
	TXMLDocument *LogXML;
private:	// User declarations
public:		// User declarations
	__fastcall TMachineDB(TComponent* Owner);
 /// Machine properties
	bool				__fastcall OpenMachineProperties();																													/// Try to read in the machine properties table
	void				__fastcall SavePropertiesTable();																														/// Save the current machine properties table
	bool				__fastcall ChangeProperty(AnsiString field,AnsiString value);																/// Edit the property in the db, post change and merge change log. Returns true if successful
	bool				__fastcall CreatePropertiesXMLRPC();																												/// Create an XML Document based on the values in the MachineProperties table
 ///Error handler
	AnsiString LastError;																																										///Contains the last error string generated
	bool 				__fastcall AddError(int errCode, AnsiString errstrn,int severity = 0,AnsiString action = " ");	///Add a record to the ErrorDB
	void 				__fastcall SaveErrorTable();																																		/// Save the current status of the error table
	bool				__fastcall CreateErrorXMLRPC();																																	/// Create a table with all of the logged errors in it
 ///XMLDoc handlers for the machine
	TXMLDocument  *GetDocument(AnsiString doc);																																	/// Return the pointer to the document named doc
	_di_IXMLNode __fastcall GetRPCNode(AnsiString doc,AnsiString name);																					/// Return the node called name in document named doc
	_di_IXMLNode __fastcall GetRPCNode(TXMLDocument *xml,AnsiString name);																	/// Return the node called name in document xmldoc
	bool    		__fastcall ChangeValue(AnsiString doc,AnsiString what,AnsiString newvalue);											/// Change the value of variable what in doc
	AnsiString 	__fastcall GetValue(AnsiString doc,AnsiString what);																						/// Get the value from doc for the what node
	bool				__fastcall GetDocFile(AnsiString name);																													/// Load the XML file for the XMLDocs
};
//---------------------------------------------------------------------------
#endif
