//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "SocketRpmSet.h"
#include "Utility.h"
#include "Machine.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TRpmSetFrm *RpmSetFrm;
//---------------------------------------------------------------------------
__fastcall TRpmSetFrm::TRpmSetFrm(TComponent* Owner)
	: TForm(Owner)
{
	bIgnore       = false;                                                      ///Set true when the Text of the edit box needs changing w/o NumberEdit handling
 ///Set the maximum speed allowed
	MaxSpeed = 60000;                                  													///Make sure the rpm cannot be set higher than the rotor type allows
	TrackBar1->Max=MaxSpeed/1000;                                               ///The track bar increments are 1000 rpm
	MTxt->Caption=(AnsiString)MaxSpeed;                                         ///Set the maximum rpm text box
 ///Get a default value for the current speed. Can be overridden.
	if(Machine->bRotorSpinning)
    CurrentSpeed = Machine->GetActualRotorSpeed();          																///If the machine is spinning, then use the current rpm
  else CurrentSpeed = Machine->GetActualRotorSpeed();		                      ///Use the desired settings if a rotor speed is not available
	NumberEdit = new TNumberEdit(this);
}
//---------------------------------------------------------------------------
void __fastcall TRpmSetFrm::FormDestroy(TObject *Sender)
{
	delete NumberEdit;
}
//---------------------------------------------------------------------------
void __fastcall TRpmSetFrm::TrackBar1Change(TObject *Sender)
{///User is sliding the trackbar
  bIgnore=true;
  Edit1->Text=(AnsiString)TrackBar1->Position;                                ///Update the edit box w/o using the NumberEdit handler
  CurrentSpeed = 1000*TrackBar1->Position;
  bIgnore=false;
}
//---------------------------------------------------------------------------
void __fastcall TRpmSetFrm::FormShow(TObject *Sender)
{///Setup the form
  TrackBar1->Position=Util->DoubleToRoundedInt((double)CurrentSpeed/1000);
  bIgnore=true;
  Edit1->Text=(AnsiString)TrackBar1->Position;
  bIgnore=false;
}
//---------------------------------------------------------------------------
void __fastcall TRpmSetFrm::OKBtnClick(TObject *Sender)
{///Save this value
  if(ed) Edit1Exit(ed);  ///Make sure the last edit box touched is OK
}
//---------------------------------------------------------------------------
//NumberEdit functions
void __fastcall TRpmSetFrm::Edit1Enter(TObject *Sender)
{
  if(bIgnore) return;
  ed = (TEdit *)Sender;
  NumberEdit->Initialize((TEdit *)Sender,0,MaxSpeed/1000,true);
}
//---------------------------------------------------------------------------
void __fastcall TRpmSetFrm::Edit1Exit(TObject *Sender)
{
  if(bIgnore) return;
  if(ed == NULL) ed = (TEdit *)Sender;
  if(!NumberEdit->ExitQuery()) ed->Text=NumberEdit->InitialText;
  bIgnore=true;
  CurrentSpeed=1000*(ed->Text).ToInt();
  TrackBar1->Position= (ed->Text).ToInt();
  ed = NULL;                                        ///Edit box is current
  bIgnore=false;
}
//---------------------------------------------------------------------------
void __fastcall TRpmSetFrm::Edit1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
  if(bIgnore) return;
  NumberEdit->KeyDown((TEdit *)Sender,Key,Shift);
}
//---------------------------------------------------------------------------

void __fastcall TRpmSetFrm::Edit1KeyPress(TObject *Sender, char &Key)
{
  TEdit * ed = (TEdit *)Sender;
	if(bIgnore || ed == NULL) return;
	if (Key == Char(VK_RETURN))
		{
			if(ed != NULL) ed->OnExit(Sender);
			Key = 0;
			PostMessage(Handle, WM_NEXTDLGCTL, 0, 0);
			return;
		}
	NumberEdit->KeyPress((TEdit *)Sender,Key);
}
//---------------------------------------------------------------------------

