//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "SocketSetTimeFrm.h"
#include "Machine.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TTimeSetFrm *TimeSetFrm;
//---------------------------------------------------------------------------
__fastcall TTimeSetFrm::TTimeSetFrm(TComponent* Owner)
	: TForm(Owner)
{
	NumberEdit = new TNumberEdit(this);
	bIgnore = true;
}
//---------------------------------------------------------------------------
void __fastcall TTimeSetFrm::HoldChkClick(TObject *Sender)
{
	if(HoldChk->Checked){																						///Don't allow entry of HHHMM
	 HEd->Enabled = false;
	 MEd->Enabled = false;
	}
	else{                																						/// Do allow entry
	 HEd->Enabled = true;
	 MEd->Enabled = true;
	}
	IsHold = HoldChk->Checked;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TTimeSetFrm::GetTimeAsString()
{/// Format strings to HHHMM format
	AnsiString s;
	AnsiString hr = HEd->Text;
	AnsiString min = MEd->Text;
	if(IsHold){
		s = "Hold";
	}
	else{
		int l = hr.Length();
		if(l < 3){																										///Pad with 0s
			double h = hr.ToDouble();
			hr = hr.FormatFloat("000",h);
		}
		l = min.Length();
		if(l < 2){
			double m = min.ToDouble();
			min = min.FormatFloat("00",m);
		}
		s = hr+min;
	}
	return s;
}
//---------------------------------------------------------------------------
void __fastcall TTimeSetFrm::FormShow(TObject *Sender)
{///Intialize the time
	long ltime = Machine->GetDesiredTimeHHHMM();
	long hrs, mins;
	mins = ltime % 100L;
	hrs =  ltime / 100L;
	bIgnore = true;
	AnsiString s = FormatFloat("000",hrs);
	HEd->Text = s;
	s = FormatFloat("00",mins);
	MEd->Text = s;
	s = Machine->GetDesiredTime();
	if(s.UpperCase() == "HOLD"){
		HoldChk->Checked = true;
	}
	bIgnore = false;
}
//---------------------------------------------------------------------------
void __fastcall TTimeSetFrm::FormKeyPress(TObject *Sender, char &Key)
{
	if(Sender->ClassNameIs("TEdit")){
		HEdKeyPress(Sender,Key);
	}
}
//---------------------------------------------------------------------------
void __fastcall TTimeSetFrm::HEdKeyPress(TObject *Sender, char &Key)
{///
	TEdit * ed = (TEdit *)Sender;
	if(bIgnore || ed == NULL) return;
	if (Key == Char(VK_RETURN))
		{
			if(ed != NULL) ed->OnExit(Sender);
			Key = 0;
			PostMessage(Handle, WM_NEXTDLGCTL, 0, 0);
			return;
		}
	NumberEdit->KeyPress((TEdit *)Sender,Key);
}
//---------------------------------------------------------------------------
void __fastcall TTimeSetFrm::FormClose(TObject *Sender, TCloseAction &Action)
{
	delete NumberEdit;
}
//---------------------------------------------------------------------------
void __fastcall TTimeSetFrm::HEdKeyDown(TObject *Sender, WORD &Key,
			TShiftState Shift)
{
	if(bIgnore) return;
	NumberEdit->KeyDown((TEdit *)Sender,Key,Shift);
}
//---------------------------------------------------------------------------
void __fastcall TTimeSetFrm::HEdEnter(TObject *Sender)
{
	TEdit * ed = (TEdit *)Sender;
	if(bIgnore) return;
	ed = (TEdit *)Sender;
	int min = 0;
	int max;
	if(ed->Name == "HEd"){
		max = 999;
	}
	else{
		max = 59;
	}
	NumberEdit->Initialize((TEdit *)Sender,min,max,true);
}
//---------------------------------------------------------------------------
void __fastcall TTimeSetFrm::HEdExit(TObject *Sender)
{
	if(bIgnore) return;
	TEdit * ed = (TEdit *)Sender;
	if(!NumberEdit->ExitQuery()) ed->Text=NumberEdit->InitialText;
}
//---------------------------------------------------------------------------

