//---------------------------------------------------------------------------

#ifndef XLSimulatorFrmH
#define XLSimulatorFrmH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
//---------------------------------------------------------------------------
class TXLSimFrm : public TForm
{
__published:	// IDE-managed Components
	TLabel *Label1;
	TLabel *TargetRpmTxt;
	TLabel *Label2;
	TLabel *LastRpmUpdateTxt;
	TLabel *Lastw2tUpdateTxt;
	TLabel *static3;
	TCheckBox *OkAcCB;
	TLabel *Label3;
	TLabel *w2tTxt;
	TBitBtn *BitBtn1;
	TBitBtn *BitBtn2;
	void __fastcall FormShow(TObject *Sender);
	void __fastcall BitBtn2Click(TObject *Sender);
	void __fastcall BitBtn1Click(TObject *Sender);
private:	// User declarations
	double LastTime;																														/// Last time rpm was updated
	double LastUpdateTime;                                                      /// Last time w2t was updated
	double w2t;                                                                 /// Local value of w2t 
public:		// User declarations
	__fastcall TXLSimFrm(TComponent* Owner);
	int TargetRpm;                                                              /// What is the ultimate rotor speed
	bool bOKToAccelerate;                                                       /// Is the vacuum set so that the rotor can accelerate
	void 				__fastcall SimulateNewRpm();																		/// Simulate acceleration/deceleration
	void 				__fastcall UpdateTime();																				/// Simulate elapsed time & w2t
	void 				__fastcall StopMachine();																				/// Set flags, etc. according to what happens when stop machine is issued
	void 				__fastcall StartMachine();																			/// Set flags, etc. according to what happens when start machine is issued
	void 				__fastcall StartPumping();																			/// Simulate what happens when the pumps are started
	void 				__fastcall CheckDesiredSettings();															/// Simulate what happens when the desired settings are checked for xmission to XL
	AnsiString 	__fastcall GetMachineStatus();																	/// Returns the simulated machine status string
	void 				__fastcall UpdateDisplay();																			/// Update form contents
};
//---------------------------------------------------------------------------
extern PACKAGE TXLSimFrm *Simulator;
//---------------------------------------------------------------------------
#endif
