//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "TextEditor.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TRTFfrm *RTFfrm;
//---------------------------------------------------------------------------
__fastcall TRTFfrm::TRTFfrm(TComponent* Owner)
	: TForm(Owner)
{
	bUnderlineOn=false;
	bBoldOn=false;
	bItalicOn=false;
	InitialPath = ExtractFilePath(Application->ExeName);
	TREOle=new TIRichEditOle(RichEdit1);
}
//---------------------------------------------------------------------------
void __fastcall TRTFfrm::FormDestroy(TObject *Sender)
{
	delete TREOle;

}
//---------------------------------------------------------------------------
void __fastcall TRTFfrm::BlankLine(int num)
{///Insert blank lines
	for(int i=0;i<num;++i) RichEdit1->Lines->Add(" ");
}
//---------------------------------------------------------------------------
void __fastcall TRTFfrm::AddLine(AnsiString s)
{/// Simply append line, no formatting
	AddLine(s,false,false,false,false,false);
}
//---------------------------------------------------------------------------
void __fastcall TRTFfrm::AddLine(AnsiString s,int size,bool ital,bool bold,bool under,bool center)
{///Adds a line of text to the RichEdit, and selects it so that the line may be formatted
  if(center)   RichEdit1->Paragraph->Alignment=taCenter;
  else   RichEdit1->Paragraph->Alignment=taLeftJustify;
  if(bold && !bBoldOn)
    {
      RichEdit1->SelAttributes->Style=RichEdit1->SelAttributes->Style << fsBold;
      bBoldOn=true;
    }
  if(!bold && bBoldOn)
    {
      RichEdit1->SelAttributes->Style=RichEdit1->SelAttributes->Style  >> fsBold;
      bBoldOn=false;
    }
  if(under && !bUnderlineOn)
    {
      RichEdit1->SelAttributes->Style=RichEdit1->SelAttributes->Style  << fsUnderline;
      bUnderlineOn=true;
    }
  if(!under && bUnderlineOn)
    {
      RichEdit1->SelAttributes->Style=RichEdit1->SelAttributes->Style  >> fsUnderline;
      bUnderlineOn=false;
    }
  if(ital && !bItalicOn)
		{
			RichEdit1->SelAttributes->Style=RichEdit1->SelAttributes->Style  << fsItalic;
			bItalicOn=true;
		}
	if(!ital && bItalicOn)
		{
			RichEdit1->SelAttributes->Style=RichEdit1->SelAttributes->Style  >> fsItalic;
			bItalicOn=false;
		}
	RichEdit1->Lines->Add(s);                      ///Add the text
}
//---------------------------------------------------------------------------
void __fastcall TRTFfrm::FileSaveAs1SaveDialogClose(TObject *Sender)
{
	if (FileSaveAs1->Execute())
		RichEdit1->Lines->SaveToFile(FileSaveAs1->Dialog->FileName);
}
//---------------------------------------------------------------------------
void __fastcall TRTFfrm::FileSaveAs1BeforeExecute(TObject *Sender)
{
	if (FileSaveAs1->Execute())
		FileSaveAs1->Dialog->InitialDir=InitialPath;
}
//---------------------------------------------------------------------------

void __fastcall TRTFfrm::FormClose(TObject *Sender, TCloseAction &Action)
{
	Action = caFree;
}
//---------------------------------------------------------------------------

void __fastcall TRTFfrm::New1Click(TObject *Sender)
{///Read in a file
	if (FileOpen1->Execute())
		 RichEdit1->Lines->LoadFromFile(FileOpen1->Dialog->FileName);
}
//---------------------------------------------------------------------------

void __fastcall TRTFfrm::Print2Click(TObject *Sender)
{///-- Print the contents
	if (PrintDlg1->Execute())
		RichEdit1->Print("");
}
//---------------------------------------------------------------------------

void __fastcall TRTFfrm::Pasteimage1Click(TObject *Sender)
{///Paste an image into the file
	TREOle->PasteBitmap();
}
//---------------------------------------------------------------------------

void __fastcall TRTFfrm::Pastespecial1Click(TObject *Sender)
{
	TREOle->PasteSpecial();
}
//---------------------------------------------------------------------------

