//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "ViewMachineErrors.h"
#include "XMLUtilities.h"
#include "Machine.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TViewMachineErrorFrm *ViewMachineErrorFrm;
//---------------------------------------------------------------------------
__fastcall TViewMachineErrorFrm::TViewMachineErrorFrm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TViewMachineErrorFrm::FormCreate(TObject *Sender)
{///Get the Servo errors from the ServoMod data base and display in the tree
	UpdateForm();
}
//---------------------------------------------------------------------------
void __fastcall TViewMachineErrorFrm::UpdateForm()
{
	XMLUtilities * xmlutil = new XMLUtilities(this);
	XMLDocument1->LoadFromXML(Machine->MachineDB->MachineErrorTable->XMLData);
	xmlutil->XML2Tree(TreeView1,XMLDocument1);
	delete xmlutil;
}
//---------------------------------------------------------------------------
void __fastcall TViewMachineErrorFrm::SaveAs1Click(TObject *Sender)
{///Save the error log
	if(SaveTextFileDialog1->Execute())
		{///Save the error log as an XML file
			Machine->MachineDB->MachineErrorTable->SaveToFile(SaveTextFileDialog1->FileName);
		}
}
//---------------------------------------------------------------------------
void __fastcall TViewMachineErrorFrm::Clearentries1Click(TObject *Sender)
{///Clear the DB entries
	Machine->MachineDB->MachineErrorTable->EmptyDataSet();																				///Empty out the records
	Machine->MachineDB->SaveErrorTable();
	UpdateForm();
}
//---------------------------------------------------------------------------

