//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "ViewMachineXML.h"
#include "Machine.h"
#include "XMLUtilities.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMachineXMLViewer *MachineXMLViewer;
//---------------------------------------------------------------------------
__fastcall TMachineXMLViewer::TMachineXMLViewer(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMachineXMLViewer::FormShow(TObject *Sender)
{/// Show the form, update everything
	UpdateComboBox();

}
//---------------------------------------------------------------------------
void __fastcall TMachineXMLViewer::UpdateComboBox()
{/// Get the list of names of the XMLDocuments on the MachineMod form
	for(int i = 0;i<Machine->MachineDB->ComponentCount;++i){
		TComponent * c = Machine->MachineDB->Components[i];
		if(c->ClassNameIs("TXMLDocument")){																		 		/// If this is an XMLDocument, add it to the list
			NamesCB->AddItem(c->Name,(TXMLDocument *)c);
		}
	}
	NamesCB->ItemIndex= 0;
	NamesCBSelect(this);    																										/// Show the first table
	SpeedButton1Click(this);                                                    /// With all of the nodes expanded
}
//---------------------------------------------------------------------------
void __fastcall TMachineXMLViewer::NamesCBKeyDown(TObject *Sender, WORD &Key,
			TShiftState Shift)
{///This combobox is read only
	return;
}
//---------------------------------------------------------------------------
void __fastcall TMachineXMLViewer::NamesCBKeyPress(TObject *Sender, char &Key)
{///This combobox is read only
	return;
}
//---------------------------------------------------------------------------
void __fastcall TMachineXMLViewer::NamesCBSelect(TObject *Sender)
{///An XMLDocument has been selected
	TXMLDocument * t = (TXMLDocument *)NamesCB->Items->Objects[NamesCB->ItemIndex];
	if(!t->Active){																															/// Make sure this this is active
	 t->Active = true;
	}
	if(t->Name == "MachinePropXML"){																						/// Have to create the Machine properties XML
		Machine->MachineDB->CreatePropertiesXMLRPC();															/// This will make a copy of the MachinePropertiesDB
	}
	XMLUtil->XML2Tree(TreeView1,t);
	SpeedButton1Click(this);                                                    /// With all of the nodes expanded
}
//---------------------------------------------------------------------------
void __fastcall TMachineXMLViewer::SpeedButton1Click(TObject *Sender)
{/// Expand the tree
	XMLUtil->TreeExpandAll(TreeView1);
}
//---------------------------------------------------------------------------

void __fastcall TMachineXMLViewer::SpeedButton2Click(TObject *Sender)
{/// Collapse the tree
	XMLUtil->TreeCollapseAll(TreeView1);
}
//---------------------------------------------------------------------------

