//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#ifndef XLCommOutH
#define XLCommOutH
#include "baXLComm.h"
#include "XLCalScanData.h"
#include "XLCalData.h"
#include "XLHWData.h"
#include "VacuumSystem.h"
#include "TemperatureSystem.h"

class XLCommOut:public baXLComm
{///All messages to the XLI are handled here
private:
  void InsertCksum(char* outmsg);
  int  CreateRequest(char* reqType, char* outmsg);
  int  CreateReqSettings(char* outmsg);
  int  CreateReqActuals(char* outmsg);
  int  CreateXlSettings(char* msgtype, char* outmsg);
  int  CreateCommand(char* cmd, char* outmsg);
  void CreateCalParms(char* outmsg);
  int  RequestElapsedTime(char* outmsg);
  int  CreateCmdStart(char* outmsg);
  int  CreateCmdStop(char* outmsg);
  bool  CreateScanSettings(char *, char *);
  bool CreateDelayScanSettings(char* msgtype, char* outmsg);
  bool CreateTimeScanSettings(char* msgtype, char* outmsg);
  bool CreateWCalScanSettings(char outmsg[]);
  bool CreateHwSettings(char* msgtype, char outmsg[]);
  bool CreateWCalPeakSettings (char *, char *);
public:
  __fastcall XLCommOut(TComponent *Owner);
  __fastcall ~XLCommOut();
 //Handle output to XL
  XLData *XLDesired;                            ///Desired values of temperature, pressure, rpm, w^2t, sent to the XL
  XLHWData *OpticsDesired;                      ///Holds the desired hw settings for the XL optical systems
  void __fastcall CreateCalScan();              ///Have to create the CalScanData objects after Machine is valid
  XLCalScanData* DlyScanSettings;               ///Settings needed for delay scan calibration
  XLCalScanData* WCalScanSettings;              ///Settings needed for wavelength scan calibration
  XLCalScanData* TimeScanSettings;              ///Settings needed for time scan calibration
  XLCalData* CalSettings;                       ///Calibration settings
	bool SendXLMessage(char* msg);                ///Format msg to be sent to the XL, add Stx/Etx and checksum
 // Temperature system
	TTemperatureSystem * TemperatureSystem;				/// Has a Temperature system
 // Vacuum system
	TVacuumSystem * VacuumSystem;                 /// This has all of the pump controls, vacuum gauge, etc.


};
//---------------------------------------------------------------------------
#endif
 